

.386
.model flat, stdcall
option casemap :none

.nolist
include windows.inc
include gdi32.inc
include kernel32.inc
include user32.inc
.list

includelib gdi32.lib
includelib kernel32.lib
includelib user32.lib

IDD_DIALOG1 = 101
IDB_BITMAP1 = 102
IDB_BITMAP2 = 103
IDS_STATIC1 = 104
IDS_STATIC2 = 105
IDC_BUTTON1 = 1000
IDC_BUTTON2 = 1001

.const
  szHide            db 'Hide',0,0,0,0
  szShow            db 'Show',0,0,0,0

.data
  hInstance         HINSTANCE NULL
  hwndStatic1       HWND      NULL
  hwndBtnHideStatic HWND      NULL
  hwndBtnHideBkgnd  HWND      NULL
  rc                RECT      <0,0,0,0>
  hbmBitmap1        HBITMAP   NULL
  hbmBitmap2        HBITMAP   NULL

.code
;-------------------------------------------------------------------;
  even
  dlgproc proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    local hwnd:HWND
    local ps:PAINTSTRUCT
    local hdc:HDC
    local hdcMem:HDC
    local buffer[16]:byte

    .if uMsg == WM_INITDIALOG
      invoke LoadBitmap, hInstance, IDB_BITMAP1
      mov hbmBitmap1,eax
      invoke LoadBitmap, hInstance, IDB_BITMAP2
      mov hbmBitmap2,eax
      invoke GetDlgItem, hDlg, IDS_STATIC1
      mov hwndStatic1, eax
      invoke SendMessage,hwndStatic1, STM_SETIMAGE , IMAGE_BITMAP, hbmBitmap1
      invoke GetDlgItem, hDlg, IDS_STATIC2
      push eax
      invoke GetWindowRect, eax, offset rc
      invoke ScreenToClient, hDlg, offset rc
      invoke ScreenToClient, hDlg, offset rc + sizeof dword + sizeof dword
      call DestroyWindow
      invoke GetDlgItem, hDlg, IDC_BUTTON1
      mov hwndBtnHideStatic, eax
      invoke SetWindowText, eax, offset szHide
      invoke GetDlgItem, hDlg, IDC_BUTTON2
      mov hwndBtnHideBkgnd, eax
      invoke SetWindowText, eax, offset szHide
      mov eax,1

    .elseif uMsg == WM_COMMAND
      mov eax,wParam
      shr eax,16
      .if eax == BN_CLICKED
        mov eax,wParam
        and eax,0FFFFh
        mov ecx,lParam
        .if (eax == IDC_BUTTON1) && (ecx == hwndBtnHideStatic)
          invoke GetWindowText, ecx, addr buffer, sizeof buffer
          invoke lstrcmp, addr buffer, offset szHide
          .if eax
            push offset szHide
            push SW_SHOW
          .else
            push offset szShow
            push SW_HIDE
          .endif
          push hwndStatic1
          call ShowWindow
          push hwndBtnHideStatic
          call SetWindowText
          mov eax,1
        .elseif (eax == IDC_BUTTON2) && (ecx == hwndBtnHideBkgnd)
          invoke GetWindowText, ecx, addr buffer, sizeof buffer
          invoke lstrcmp, addr buffer, offset szHide
          .if eax
            push offset szHide
          .else
            push offset szShow
          .endif
          push hwndBtnHideBkgnd
          call SetWindowText
          invoke InvalidateRect, hDlg, NULL, TRUE
          invoke UpdateWindow, hDlg
          mov eax,1
        .else
          xor eax,eax
        .endif
      .else
        xor eax,eax
      .endif

    .elseif uMsg == WM_PAINT
       invoke BeginPaint, hDlg, addr ps
       mov hdc,eax
       invoke GetWindowText, hwndBtnHideBkgnd, addr buffer, sizeof buffer
       invoke lstrcmp, addr buffer, offset szHide
       .if !eax
         invoke CreateCompatibleDC, hdc
         mov hdcMem,eax
         invoke SelectObject, hdcMem, hbmBitmap2
         push eax
         push hdcMem
         invoke BitBlt, hdc, rc.left, rc.top, rc.right, rc.bottom, hdcMem, 0, 0, SRCCOPY
         call SelectObject
         invoke DeleteDC, hdcMem
       .endif
       invoke EndPaint, hDlg, addr ps
       mov eax,1

    .elseif uMsg == WM_CLOSE
      invoke EndDialog, hDlg, 0
      mov eax,1

    .elseif
      xor eax,eax
    .endif
    ret
  dlgproc endp

;---------------------------------------------------------;
  even
  _start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke DialogBoxParam, eax, IDD_DIALOG1, 0, dlgproc, 0
    invoke ExitProcess, eax

end _start
